/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.List;

import jp.mosp.common.dto.HumanBasisDtoInterface;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.dao.MKaisyaDao;
import jp.mosp.kintai.common.dto.MKaisyaDto;

/**
 * 事業所に関するPartクラス
 * @author yoshida
 * 	@version	0.0.1
 */
public class OfficePart extends KintaiBasePart {
	
	/**
	 * コンストラクタ
	 */
	public OfficePart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo Partを利用する際に必要な情報
	 */
	public OfficePart(PartInfo partInfo) {
		super(partInfo);
	}
	

	private MKaisyaDao	kaisyaDao;
	

	/**
	 * M_KAISYAテーブル用のDAO取得
	 * @return	初期化済みMKaisyaDaoインスタンス
	 * @throws Exception	例外処理が発生した場合
	 */
	public MKaisyaDao getMKaisyaDao() throws Exception {
		if (VariousUtil.isNull(kaisyaDao)) {
			kaisyaDao = (MKaisyaDao)getPreparedDao(MKaisyaDao.class.getCanonicalName());
		}
		return kaisyaDao;
	}
	
	/**
	 * 事業所情報取得(M_KAISYA)
	 * @param jCode 情報取得対象事業所コード
	 * @return 事業所情報(MKaisyaDto)
	 * @throws Exception 	例外処理が発生した場合
	 */
	public MKaisyaDto getOfficeInfo(String jCode) throws Exception {
		// 情報の取得
		return getMKaisyaDao().findForKey(jCode);
	}
	
	/**
	 * 事業所名称取得
	 * @param jCode	 情報取得対象事業所コード
	 * @return	事業所名称
	 * @throws Exception	例外処理が発生した場合
	 */
	public String getOfficeName(String jCode) throws Exception {
		MKaisyaDto dto = getOfficeInfo(jCode);
		if (VariousUtil.isNotNull(dto)) {
			return dto.getKaiMei();
		}
		return "";
	}
	
	/**
	 * 事業所コード取得(M_KAISYA)
	 * @return 事業所コードリスト
	 * @throws Exception 	例外処理が発生した場合
	 */
	public String[][] getOfficeArrayAll() throws Exception {
		// 情報の取得
		List<MKaisyaDto> listOffice = getMKaisyaDao().findAll();
		// 配列の作成
		String[][] aryOffice = new String[listOffice.size()][2];
		for (int i = 0; i < aryOffice.length; i++) {
			aryOffice[i][0] = listOffice.get(i).getId();
			aryOffice[i][1] = listOffice.get(i).getKaiMei();
		}
		return aryOffice;
	}
	
	/**
	 * 事業所コード取得(利用可能所属のみ)(M_KAISYA)
	 * @return 事業所コードリスト
	 * @throws Exception	例外処理が発生した場合
	 */
	public String[][] getOfficeArray() throws Exception {
		// 情報の取得
		List<MKaisyaDto> listOffice;
		if (part().authority().hasPayrollAuth()) {
			listOffice = getMKaisyaDao().findAll();
		} else {
			listOffice = getMKaisyaDao().findForCondition(part().human().getBasisInfoOfUser().getJCode());
		}
		// 配列の作成
		String[][] aryOffice = new String[listOffice.size()][2];
		for (int i = 0; i < aryOffice.length; i++) {
			aryOffice[i][0] = listOffice.get(i).getId();
			aryOffice[i][1] = listOffice.get(i).getKaiMei();
		}
		return aryOffice;
	}
	
	/**
	 * 事業所コード取得（所属のみ）(M_KAISYA)
	 * @param kCode 取得対象社員コード
	 * @return 事業所コード
	 * @throws Exception	例外処理が発生した場合
	 */
	public String getBelongOfficeCode(String kCode) throws Exception {
		// 人事基本情報取得
		HumanBasisDtoInterface mKihonDto = part().human().getBasisInfo(kCode);
		if (VariousUtil.isNotNull(mKihonDto)) {
			return mKihonDto.getJCode();
		}
		return "";
	}
	
}
